//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                


#if 1
#include "base64/base64.c"
#else
extern void *b64_out_buf, *b64_in_buf;
extern int b64_out_bufsize, b64_in_bufsize;
extern int b64_in_readsize;
extern char *b64_err_msg;

extern void encode(void);
extern void decode(void);
extern int ateof; 
#endif

#include <SGM_def.h>


void init_base64_vars()
{
    ateof = FALSE;
    iolen = 0;
    iocp = MAXINLINE;
    linelength = 0;
}

//int SGM_b64_convert(MemoryFile *inFile, MemoryFile *outFile, Uint8 type)
//{
//    if(((inFile == NULL) || (inFile->data == NULL)) || ((outFile == NULL)  || (outFile->data == NULL)))
//        return -1;
//    // set b64 variables
//    ateof = FALSE;
//    b64_out_buf = NULL;
//    b64_out_bufsize = 0;
//    
//    b64_in_buf = inFile->data;
//    b64_in_bufsize = inFile->size;
//    b64_in_readsize = 0;
//    
//    b64_err_msg = NULL;
//    
//    if(type == 0)
//        encode();
//    else decode();
//    if(b64_err_msg != NULL) {
//        if(b64_out_bufsize > 0)
//            free(b64_out_buf);
//        return -2;
//    }
//    outFile->data = b64_out_buf;
//    outFile->size = b64_out_bufsize;
//    
//    return 0;
//}

int SGM_b64_encode(MemoryFile *inFile, MemoryFile *outFile)
{
    if(((inFile == NULL) || (inFile->data == NULL)) || (outFile == NULL)) {
        b64_err_msg = "wrong arguments";
        return -1;
    }

//waitRelease(PER_DGT_ST);        
    // set some b64 variables
    init_base64_vars();
    b64_err_msg = NULL;
    b64_out_buf = NULL;
    b64_out_bufsize = 0;
    b64_out_writesize = 0;
    // 1. encode MemoryFile structure
        // set b64 variables
    b64_in_buf = inFile;
    b64_in_bufsize = sizeof(MemoryFile);
    b64_in_readsize = 0;
    
//were_here("1st encode: data");
    encode();
//were_here("finished 1nd encode");
    if(b64_err_msg != NULL) {
        if(b64_out_bufsize > 0)
            free(b64_out_buf);
        return -2;
    }
//were_here("sizeof(mFile): %i b64", b64_out_writesize);
    if(inFile->size > 0) {
        // 2. encode data
            // set b64 variables
        init_base64_vars();
        b64_in_buf = inFile->data;
        b64_in_bufsize = inFile->size;
        b64_in_readsize = 0;
    //were_here("2nd encode: data"); 
        encode();
    //were_here("finished 2nd encode");
        if(b64_err_msg != NULL) {
            if(b64_out_bufsize > 0)
                free(b64_out_buf);
            return -2; 
        }
    }
    // 3. finish
    outFile->data = b64_out_buf;
    outFile->size = b64_out_writesize;
    
    return 0;
}
//????????????????
int SGM_b64_decode(MemoryFile *inFile, MemoryFile *outFile)
{
    if( ((inFile == NULL) || (inFile->data == NULL) || (inFile->size < 58)) || (outFile == NULL) ) {
        b64_err_msg = "wrong arguments";
        return -1;
    } 
//were_here("start decode b64");        
    // set some b64 variables
    init_base64_vars();
    b64_in_buf = inFile->data; 
    b64_in_bufsize = 58;   // sizeof(MemoryFile) = 40 bytes -> 14 triplets -> 14*4 + (sizeof(eol)-1) = 59 characters
    b64_in_readsize = 0;
    b64_err_msg = NULL;
    // 1. decode MemoryFile structure
        // set b64 variables
    b64_out_buf = outFile;
    b64_out_bufsize = sizeof(MemoryFile);
    b64_out_writesize = 0;
    
//were_here("before 1st decode");        
    decode();
//were_here("after 1st decode");        
    if(b64_err_msg != NULL) {
        if(b64_out_bufsize > 0)
            free(b64_out_buf);
        return -2;
    }

    // support empty files
    if(outFile->size > 0) {
        // 2. encode data
            // set b64 variables
        init_base64_vars();
    //    b64_in_buf = inFile->data;
        b64_in_bufsize = inFile->size;
    //    b64_in_readsize = 0;
        b64_out_buf = NULL;
        b64_out_bufsize = 0;
        b64_out_writesize = 0;
        
    //were_here("before 2nd decode");        
        decode();
    //were_here("after 2nd decode");        
        if(b64_err_msg != NULL) {
            if(b64_out_bufsize > 0)
                free(b64_out_buf);
            return -2;
        }
        // 3. finish
        outFile->data = b64_out_buf;
        if(outFile->size != b64_out_writesize) {
            b64_err_msg = "wrong file size";  
            if(b64_out_bufsize > 0)
                free(b64_out_buf);
            return -2;
        }
    }
//    were_here("finished");
    return 0;
}


// assume the file is base64 encoded
// only page-wise scrolling
void SGM_b64_viewer(MemoryFile *mFile)
{
    clearScreen();
    while(1) {
    
        slSynch();
    }
}




