//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#ifndef HAVE_SGM_DEVICE_H
#define HAVE_SGM_DEVICE_H

#include <SGM_def.h>

#define DEVICE_SLOT_0   0
#define DEVICE_SLOT_1   1

#define aDevice (device + activeDevices[activeSlot])
#define iDevice (device + activeDevices[inactiveSlot])

#ifdef __cplusplus
extern "C" {
#endif

char *deviceNames[5];
char filename_NULL[13];
char comment_NULL[12];

// which device is active in which slot
Uint8 activeSlot, inactiveSlot;
Uint8 activeDevices[2];
// device list
Uint8 nDevices;
StorageDevice *device;

int stringsEqual(char *a, char *b);

/****************************************************************************************************/
/* Backup RAM interface *****************************************************************************/
/****************************************************************************************************/

int init_BackUp();

int updateDir_Backup(struct STORAGE_DEVICE *sDevice);
int getFileNum_Backup(struct STORAGE_DEVICE *sDevice);
int getFreeBytes_Backup(struct STORAGE_DEVICE *sDevice);
char *getName_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
char *getComment_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getSize_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getDate_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int loadFile_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int saveFile_Backup(struct STORAGE_DEVICE *sDevice, MemoryFile *mFile);
int deleteFile_Backup(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int format_Backup(struct STORAGE_DEVICE *sDevice);

/****************************************************************************************************/
/* Virtual Drive interface **************************************************************************/
/****************************************************************************************************/

int updateDir_Virtual(struct STORAGE_DEVICE *sDevice);
int getFileNum_Virtual(struct STORAGE_DEVICE *sDevice);
int getFreeBytes_Virtual(struct STORAGE_DEVICE *sDevice);
char *getName_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
char *getComment_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getSize_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getDate_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int loadFile_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int saveFile_Virtual(struct STORAGE_DEVICE *sDevice, MemoryFile *mFile);
int deleteFile_Virtual(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int format_Virtual(struct STORAGE_DEVICE *sDevice);

/****************************************************************************************************/
/* CD Drive interface *******************************************************************************/
/****************************************************************************************************/

void init_CD();
int CdUnlock (void);

int updateDir_CD(struct STORAGE_DEVICE *sDevice);
int getFileNum_CD(struct STORAGE_DEVICE *sDevice);
int getFreeBytes_CD(struct STORAGE_DEVICE *sDevice);
char *getName_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
char *getComment_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getSize_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int getDate_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int loadFile_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex, MemoryFile *mFile);
int isDir_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);
int changeDir_CD(struct STORAGE_DEVICE *sDevice, Uint16 fIndex);



#ifdef __cplusplus
}
#endif

#endif //HAVE_SGM_DEVICE_H
