//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#include <SGL.H>
#include <SGM_def.h>
#include <SGM_BZip2.h>
#include <SGM_action.h>
#include <SGM_device.h>
#include <SGM_popup.h>
#include <SGM_string.h>
#include <SGM_base64.h>



/****************************************************************************************************/
/* help pages with special options ******************************************************************/
/****************************************************************************************************/

char *HELP_P1[] = {
    "                                            ",
    "        Rockin'-B's Save Game Manager       ",
    "                                            ",
    "   START - open main menu, hide help        ",
    "                                            ",
    "-------- control cursor & selection --------",
    "                                            ",
    "   X          - toggle device slot          ",
    "   LEFT/RIGHT - change storage device       ",
    "   UP/DOWN    - change file (slow)          ",
    "   L/R        - change file (fast)          ",
    "                                            ",
    "------------ file management ---------------",
    "                                            ",
    "  1. button  2. confirm/cancel  3. message  ",
    "     CONFIRM  with same button              ",
    "     CANCEL   with different button or      ",
    "              wait for 10s                  ",
    "                                            ",
    "   A - COPY   file from active slot device  ",
    "              to inactive slot, or          ",
    "     - CHANGE DIR                           ",
    "   B - DELETE file from active slot         ",
    "   C - FORMAT active slot device            ",
    "   Y - OPEN   file from active slot         ",
    "              as new VIRTUAL DRIVE          ",
    "   Z - SAVE   active slot device compressed ",
    "              to inactive slot device       ",
    "                                            ",
    "              www.rockin-b.de               ",
};

//char *HELP_P2[] = {
//    "                                            ",
//    "        Rockin'-B's Save Game Manager       ",
//    "                                            ",
//    ">>>> help page 2/2    toggle with START <<<<",
//    "                                            ",
//    "     This page allows special stuff:        ",
//    "                                            ",
//    "----------------- swap CD ------------------",
//    "                                            ",
//    "   L - stop CD       R - rescan CD          ",
//    "                                            ",
//    "----------- compression quality ------------",
//    "                                            ",
//    "   compression level is:                    ",
//    "   A - decrease                             ",
//    "   B - increase      1MB RAM Cart: no change",
//    "                     4MB RAM Cart: up to 4  ",
//    "                                            ",
//    "   decompression type is:                   ",
//    "   C - toggle small/slow and big/fast       ",
//    "                                            ",
//    "------- flash Action Replay Cartridge ------",
//    "           !!! use with care !!!            ",
//    "                                            ",
//    "   select firmware:                         ",
//    "   X - Datel Action Replay                  ",
//    "   Y - Action Replay 4M Plus                ",
//    "   Z - Action Replay Plus                   ",
//    "                                            ",
//    "              www.rockin-b.de               ",
//};

void SGM_help()
{
    int i;
// page 1    
    for(i = 0; i < (sizeof(HELP_P1)/sizeof(char *)); i++)
        slPrint(*(HELP_P1 + i), slLocate(0, i));

    waitRelease(PER_DGT_ST);

    // wait press
    while(1) {
        Uint16 push;
        getfirstPadInput(NULL, &push, NULL);
        if((push & PER_DGT_ST) == 0)
            break;
        slSynch();
    }

#if 0
// page 2        
    // wait release
    while((Smpc_Peripheral[0].data & PER_DGT_ST) == 0) {
        checkExit();
        slSynch();
    }    

    while(1) {
        Uint16 push = Smpc_Peripheral[0].push;
        checkExit();

        if((push & PER_DGT_ST) == 0)
            break;
        else if((push & PER_DGT_TL) == 0) {
            // 0. stop CD on L
            CdcPos poswk;
            // seek home position
            CDC_POS_PTYPE(&poswk) = CDC_PTYPE_DFL;
            CDC_CdSeek(&poswk);
        } else if((push & PER_DGT_TR) == 0) {
            // 1. rescan CD on  R
            updateDir_CD(device + DEVICE_CD_DRIVE);
        } else if((push & PER_DGT_TC) == 0) {
            // 2. toggle small & slow and big & fast decompression
            if(small == 0)
                small = 1;
            else small = 0;
        } else if((push & PER_DGT_TA) == 0) {
            // 3. decrease compression quality
            if(blockSize100k > 1)
                blockSize100k--;
        } else if((push & PER_DGT_TB) == 0) {
            // 4. limit compression quality increase
            // by available cart RAM
            if(((CartID == CARTRAM_ID_8M) && (blockSize100k < 2)) || ((CartID == CARTRAM_ID_32M) && (blockSize100k < 4)))
                blockSize100k++;
        } else if((push & PER_DGT_TX) == 0) {
            // 5. flash datel cart
            if(SGM_confirm(PER_DGT_TX, CONFIRM_FLASH_DATEL, "Datel AR"))
                flash("datel.bin");
        } else if((push & PER_DGT_TY) == 0) {
            // 6. flash EMS cart
            if(SGM_confirm(PER_DGT_TX, CONFIRM_FLASH_AR4MP, "EMS AR4MP"))
                flash("ar4mp.bin");
        } else if((push & PER_DGT_TZ) == 0) {
            // 7. flash ARP cart
            if(SGM_confirm(PER_DGT_TX, CONFIRM_FLASH_ARP, "ARP"))
                flash("arp.bin");
        }
        
        // redraw
        for(i = 0; i < (sizeof(HELP_P2)/sizeof(char *)); i++)
            slPrint(*(HELP_P2 + i), slLocate(0, i));

        slPrintFX(blockSize100k << 16, slLocate(27, 13));
        slPrint((small == 0 ? "fast" : "small"), slLocate(32, 18));

        slSynch();
    }
#endif
    // wait release, again -> no deadlock
    waitRelease(PER_DGT_ST);
}



Uint32 startAddr = 0x22000000, endAddr = 0x22000000 + 256*1024;
static Uint8 cursor = 0;

enum {
    MENU_VIEW_HELP,
    MENU_VIEW_MEMORY,
    MENU_ENTER_BUTTON_CODE,
    MENU_VIEW_BASE64,
    MENU_DECODE_BASE64,
    MENU_VIEW_BUTTON_CODE,
    MENU_VIEW_HEX,
    MENU_COPY,
    MENU_DELETE,
    MENU_UNCOMPRESS,
    MENU_SPLIT,
    MENU_FLASH_ACTION_REPLAY,
    MENU_COMPRESS,
    MENU_JOIN,
    MENU_FORMAT,
    MENU_DECOMPRESS_TYPE,
    MENU_COMPRESS_LEVEL,
    MENU_SET_START,
    MENU_SET_END,
    MENU_DUMP,
    MENU_CD_STOP,
    MENU_CD_RESCAN,
    MENU_N
};

Uint8 cursorPos[MENU_N][XY] = {
    {13,  1},
    {23,  1},
    { 8,  2},
    { 6,  5},
    { 6,  6},
    { 6,  7},
    { 6,  8},
    { 6,  9},
    { 6, 10},
    { 6, 11},
    { 6, 12},
    { 6, 13},
    { 9, 16},
    { 9, 17},
    { 9, 18},
    {11, 21},
    {11, 22},
    {13, 25},
    {13, 26},
    {13, 27},
    {31,  8},
    {31,  9},
};


char *MENU[] = {
    "                                          W ",
    "   view help             view memory      W ",
    "          enter button code               W ",
    "                                            ",
    "    |---- File: ------------|             . ",
    "    |   view/save as base64 |               ",
    "    |   decode base64       |             R ",
    "    |   view as button code ||- CD ----|  O ",
    "    |   view as hex         ||   stop  |  C ",
    "    |   copy                ||   rescan|  K ",
    "    |   delete              ||---------|  I ",
    " W  |   uncompress          |             N ",
    " W  |   split               |             - ",
    " W  |   flash Action Replay |             B ",
    "    |-----------------------|               ",
    " .     |---- Device: -----------------|   . ",
    "       |   compress                   |     ",
    " R     |   join all files             |   D ",
    " O     |   format                     |   E ",
    " C     |------------------------------|     ",
    " K       |---- BZip 2 options ---------|    ",
    " I       |   decompression type:       |    ",
    " N       |   compression level:        |    ",
    " -       |-----------------------------|    ",
    " B         |---- dump memory-------|        ",
    "           |   set start:          |        ",
    " .         |   set end:            |        ",
    "           |   dump as file        |        ",
    " D         |-----------------------|        ",
    " E                                          ",
};


void SGM_menu_draw()
{
    int i;
    // background    
    for(i = 0; i < (sizeof(MENU)/sizeof(char *)); i++)
        slPrint(*(MENU + i), slLocate(0, i));

    // cursor
    slPrint("*", slLocate(cursorPos[cursor][X], cursorPos[cursor][Y]));

    // values
    slPrint(aDevice->getName(aDevice, aDevice->fIndex), slLocate(16, 4));
    slPrint(aDevice->name, slLocate(21, 15));
    
    slPrint((small == 0 ? "fast" : "small"), slLocate(33, 21));
    slPrintFX(blockSize100k << 16, slLocate(30, 22));
    slDispHex(startAddr, slLocate(26, 25));
    slDispHex(endAddr, slLocate(26, 26));
}

void SGM_menu()
{
    Uint8 redraw;
    Uint16 data, push;
    
    SGM_menu_draw();
    waitRelease(PER_DGT_ST | PER_DGT_TA | PER_DGT_TB | PER_DGT_TC);

    while(1) {
        getfirstPadInput(&data, &push, NULL);
        redraw = 0;
        // exit ?
        if(((push & PER_DGT_ST) == 0) || ((push & PER_DGT_TB) == 0)) {
            waitRelease(PER_DGT_ST | PER_DGT_TA | PER_DGT_TB | PER_DGT_TC | PER_DGT_TX | PER_DGT_TY | PER_DGT_TZ);
            return;
        }        
        // cursor change
        else if(((push & PER_DGT_KU) == 0) || ((data & PER_DGT_TL) == 0) || ((data & PER_DGT_KL) == 0)) {
            if(cursor == 0)
                cursor = MENU_N-1;
            else cursor--;
            redraw = 1;
        } else if(((push & PER_DGT_KD) == 0) || ((data & PER_DGT_TR) == 0) || ((data & PER_DGT_KR) == 0)) {
            if(cursor == (MENU_N-1))
                cursor = 0;
            else cursor++;
            redraw = 1;
        }    
        // perform action
        else if(((push & PER_DGT_TA) == 0) || ((push & PER_DGT_TC) == 0)) {
            redraw = 1;
            switch(cursor) {
                case MENU_VIEW_HELP:
                    SGM_help();
                    break;
                    
                case MENU_VIEW_MEMORY:
                    {
                        Uint8 *addr = (Uint8 *)0x26004000;
                        SGM_MemoryViewer(&addr, 0x20000000, 0x26100000-1);
                    }
                    break;
                    
                case MENU_ENTER_BUTTON_CODE:
                    {
                        int ret;
                        MemoryFile mFile;
                        // set up file
                        mFile.data = NULL;
                        mFile.size = 0;
                            // write default file attributes
                        set_date(&mFile);
                        char comment[] = "My_Comment";
                        memcpy(mFile.comment, comment, 11);
                        char name[] = "My_File____";
                        memcpy(mFile.name, name, 12);
//                        SGM_string("Specify file name:", 11, mFile.name);
//                        SGM_string("Specify file comment:", 10, mFile.comment);
                        // get the data                    
                        SGM_IO_pad(&mFile, 1);
                        while((Smpc_Peripheral[0].data & PER_DGT_ST) == 0)
                            slSynch();
//                        were_here("ptr: %x data: %2x %2x %2x %2x...", mFile.data, *(ptr+0), *(ptr+1), *(ptr+2), *(ptr+3));
                        
                        // save
//                        if(mFile.size > 0) {
                            // create a new empty virtual drive
                            if(appendDevice(DEVICE_VIRTUAL) == 0) {
                                // show new drive in unselected slot
                                activeDevices[inactiveSlot] = nDevices - 1;
                                ret = iDevice->saveFile(iDevice, &mFile);
                                if(ret == 0) {
                                    // update dir and screen
                                    //iDevice->updateDir(iDevice);
                                    SGM_draw();
                                    SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, mFile.name);
                                } else {
                                    // remove the virtual drive
                                    // delete all files
                                    iDevice->format(iDevice);
                                    SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, mFile.name);
                                }    
                            } else SGM_confirm(0xFFFF, CONFIRM_ERROR, "appending Device");
//                        while((Smpc_Peripheral[0].data & PER_DGT_ST) == 0)
//                            slSynch();
//                        were_here("mFile: %x data: %2x %2x %2x %2x...", mFile.data, *(((Uint8 *)mFile.data)+0), *(((Uint8 *)mFile.data)+1), *(((Uint8 *)mFile.data)+2), *(((Uint8 *)mFile.data)+3));
                            if(mFile.size > 0)
                                free(mFile.data);
//                        }
                    }    
                    break;
                    
                case MENU_VIEW_BASE64:
                    {
                        MemoryFile inFile, outFile;
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &inFile);
                        if(ret == 0) {
                            ret = SGM_b64_encode(&inFile, &outFile);
                            if(ret == 0) {
//                                were_here("sz %i, da %x", outFile.size, outFile.data);
                                Uint8 *addr = outFile.data;
                                SGM_MemoryViewer(&addr, (Uint32)outFile.data, (Uint32)(outFile.data + outFile.size - 1));
                                // save the file ?
                                if(SGM_confirm(PER_DGT_TA, CONFIRM_SAVE, inFile.name)) {
                                    set_date(&outFile);
                                    char comment[] = "Base64View";
                                    memcpy(outFile.comment, comment, 11);
                                    char name[] = "My_File_B64";
                                    memcpy(outFile.name, name, 12);
                                    SGM_string("Specify file name:", 11, outFile.name);
                                    SGM_string("Specify file comment:", 10, outFile.comment);
                                    if(iDevice->saveFile(iDevice, &outFile) == 0) {
                                        SGM_draw();
                                        SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, outFile.name);
                                    } else {
                                        // display dir changes
                                        SGM_draw();
                                        SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, outFile.name);
                                    }
                                }
                                // free file memory
                                if(outFile.size > 0)
                                    free(outFile.data);      
                            } else SGM_confirm(0xFFFF, CONFIRM_ERROR, b64_err_msg);
                            // free file memory
                            if(inFile.size > 0)
                                free(inFile.data);      
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }    
                    break;
                    
                case MENU_DECODE_BASE64:
                    {
                        MemoryFile inFile, outFile;
                        
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &inFile);
                        if(ret == 0) {
                            ret = SGM_b64_decode(&inFile, &outFile);
                            if(ret == 0) {
//                                were_here("sz %i, da %x", outFile.size, outFile.data);
                                // create a new empty virtual drive
                                if(appendDevice(DEVICE_VIRTUAL) == 0) {
                                    // show new drive in unselected slot
                                    activeDevices[inactiveSlot] = nDevices - 1;
                                    ret = iDevice->saveFile(iDevice, &outFile);
                                    if(ret == 0) {
                                        // update dir and screen
                                        //iDevice->updateDir(iDevice);
                                        SGM_draw();
                                        SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, outFile.name);
                                    } else {
                                        // remove the virtual drive
                                        // delete all files
                                        iDevice->format(iDevice);
                                        SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, outFile.name);
                                    }    
                                } else SGM_confirm(0xFFFF, CONFIRM_ERROR, "appending Device");
                                // free file memory
                                if(outFile.size > 0)
                                    free(outFile.data);      
                            } else SGM_confirm(0xFFFF, CONFIRM_ERROR, b64_err_msg);
                            // free file memory
                            if(inFile.size > 0)
                                free(inFile.data);      
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }    
                    break;
                    
                case MENU_VIEW_BUTTON_CODE:
                    {
                        MemoryFile mFile;
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &mFile);
                        if(ret == 0) {
                            SGM_IO_pad(&mFile, 0);
                            // free compressed file memory
                            if(mFile.size > 0)
                                free(mFile.data);      
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }    
                    break;
                    
                case MENU_VIEW_HEX:
                    {
                        MemoryFile mFile;
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &mFile);
                        if(ret == 0) {
                            Uint8 *addr = mFile.data;
                            SGM_MemoryViewer(&addr, (Uint32)mFile.data, (Uint32)(mFile.data + mFile.size - 1));
                                  // free compressed file memory
                            if(mFile.size > 0)
                                free(mFile.data);      
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }    
                    break;
                    
                case MENU_COPY:
                    SGM_copy();
                    break;
                    
                case MENU_DELETE:
                    SGM_delete();
                    break;
                    
                case MENU_UNCOMPRESS:
                    SGM_open();
                    break;
                    
                case MENU_SPLIT:
                    {
                        // load file
                        MemoryFile mFile;
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &mFile);
                        if(ret == 0) {
                            char str[5] = "0032";
                            int i;
                            Uint16 blocks = 0;
                            // request split size
                            SGM_string("Specify blocksize(digits only):", 4, str);
                            for(i = 0; i < 4; i++) {
                                if((str[i] >= '0') || (str[i] <= '9'))
                                    blocks *= 10;
                                    blocks += ((Uint16)(str[i] - '0'));
                            }
//                            waitRelease(PER_DGT_ST);
//                            were_here("blocks: %i", blocks);
                            // create a new empty virtual drive
                            if(appendDevice(DEVICE_VIRTUAL) == 0) {
                                MemoryFile tmpFile;
                                int o;
                                // show new drive in unselected slot
                                activeDevices[inactiveSlot] = nDevices - 1;
                                // prepare tmpFile
                                    // write file attributes
                                set_date(&tmpFile);
                                char comment[] = "My_Comment";
                                memcpy(tmpFile.comment, comment, 11);
                                char name[] = "My_File_000";
                                memcpy(tmpFile.name, name, 12);
                                SGM_string("Specify file name prefix:", 7, tmpFile.name);
                                tmpFile.name[7] = '_';  // overwrite '\0'
                                SGM_string("Specify file comment:", 10, tmpFile.comment);
                                // split and save
                                for(o = -blocks*64; o < ((signed int)mFile.size); o += blocks*64) {
                                    // prepare file
                                        // data & size
                                    if(o < 0) {
                                        // save file attributes as <fileprefix>_000
                                        tmpFile.data = &mFile;
                                        tmpFile.size = sizeof(MemoryFile);
                                    } else {
                                        tmpFile.data = mFile.data + o;
                                        tmpFile.size = blocks*64;
                                        if((o + blocks*64) > mFile.size)
                                            tmpFile.size = mFile.size - o;
                                    }
                                    // save
                                    ret = iDevice->saveFile(iDevice, &tmpFile);
                                    if(ret != 0) {
                                        // remove the virtual drive
                                        // delete all files
                                        iDevice->format(iDevice);
                                        SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, tmpFile.name);
                                    } else SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, tmpFile.name);
                                    // update file name
//                            were_here("old name: %s", tmpFile.name);
                                    tmpFile.name[10]++;
                                    if(tmpFile.name[10] > '9') {
                                        tmpFile.name[10] = '0';
                                        tmpFile.name[9]++;
                                        if(tmpFile.name[9] > '9') {
                                            tmpFile.name[9] = '0';
                                            tmpFile.name[8]++;
                                        }
                                    }
//                            were_here("new name: %s", tmpFile.name);
                                }                                
                            } else SGM_confirm(0xFFFF, CONFIRM_ERROR, "appending Device");
                                  // free temporary file memory
                            if(mFile.size > 0)
                                free(mFile.data);      
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }
                    break;
                    
                case MENU_FLASH_ACTION_REPLAY:
                    if(SGM_confirm(PER_DGT_TA | PER_DGT_TC, CONFIRM_FLASH, aDevice->getName(aDevice, aDevice->fIndex))) {
                        MemoryFile mFile;
                        extern Uint16* arrom;
                        extern Uint32 len;
                        extern void flash_main(void);
                        int ret = aDevice->loadFile(aDevice, aDevice->fIndex, &mFile);
                        if(ret == 0) {
                            // check header ip
                            if(memoryEqual(mFile.data, "SEGA SEGASATURN ", 16)) {
                                // show overwrite warnings, if the firmware would overwrite codes and save games
                                if((mFile.size <= 0x10000) || ((mFile.size < 0x14BF0) && SGM_confirm(PER_DGT_TA | PER_DGT_TC, CONFIRM_FLASH, "+ codes?")) || ((mFile.size >= 0x14BF0) && SGM_confirm(PER_DGT_TA | PER_DGT_TC, CONFIRM_FLASH, "+ codes + saves?"))) {
                                    // flash parameters
                                    arrom = (Uint16 *)mFile.data;
                                    len = mFile.size;
                                    clearScreen();
                                    // run flash app
                                    flash_main();
                                    // never reach
                                    // no need to free
                                }
                            } else SGM_confirm(0xFFFF, CONFIRM_ERROR, "wrong firmware");
                        } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, aDevice->fIndex));
                    }    
                    break;
                    
                case MENU_COMPRESS:
                    SGM_save();
                    break;
                    
                case MENU_JOIN:
                    {
                        Uint32 i, n = aDevice->getFileNum(aDevice);
                        MemoryFile mFile, tmpFile;
                        Uint32 size = 0;
                        char suf[] = "_000";
                        mFile.size = 0; // to avoid wrong free
                        for(i = 0; i < n; i++) {
//                        were_here("name should %s is %s", suf, aDevice->getName(aDevice, i) + 7);
                            // check suffix
                            if(!stringsEqual(suf, aDevice->getName(aDevice, i) + 7)) {
                                SGM_confirm(0xFFFF, CONFIRM_ERROR, "wrong filename");
                                goto finish_join;
                            }
                            int ret = aDevice->loadFile(aDevice, i, &tmpFile);
                            if(ret == 0) {
                                if(i == 0) {
                                    // check and create MemoryFile structure
                                    if(tmpFile.size == sizeof(MemoryFile))
                                        memcpy(&mFile, tmpFile.data, sizeof(MemoryFile));
                                    else {
                                        SGM_confirm(0xFFFF, CONFIRM_ERROR, "wrong first file");
                                        // free tmp file
                                        if(tmpFile.size > 0)
                                            free(tmpFile.data);
                                        goto finish_join;
                                    }
                                } else {
                                    void *ptr;
                                    // alloc
//                                    were_here("data %x sz %i tmpSz %i", mFile.data, size, tmpFile.size);
                                    if(i == 1)
                                        ptr = (void *)malloc(tmpFile.size);
                                    else ptr = (void *)realloc(mFile.data, size + tmpFile.size);
//                                    were_here("copy");
                                    if(ptr != NULL) {
                                        // copy
                                        mFile.data = ptr;
                                        memcpy(mFile.data + size, tmpFile.data, tmpFile.size);
                                        size += tmpFile.size;
                                    } else {
                                        SGM_confirm(0xFFFF, CONFIRM_ERROR, "memory error");
                                        // free tmp file
                                        if(tmpFile.size > 0)
                                            free(tmpFile.data);
                                        goto finish_join;
                                    }
                                }
//                                were_here("free");
                                // free tmp file
                                if(tmpFile.size > 0)
                                    free(tmpFile.data);
                                // update file name
                                suf[3]++;
                                if(suf[3] > '9') {
                                    suf[3] = '0';
                                    suf[2]++;
                                    if(suf[2] > '9') {
                                        suf[2] = '0';
                                        suf[1]++;
                                    }
                                }
                            } else SGM_confirm(0xFFFF, CONFIRM_LOAD_ERROR, aDevice->getName(aDevice, i));
                        }
                        // make a final size check
                        if(mFile.size != size)
                            SGM_confirm(0xFFFF, CONFIRM_ERROR, "wrong total size");
                        // save joined file
                        if(iDevice->saveFile(iDevice, &mFile) == 0) {            
                            SGM_draw();
                            SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, mFile.name);
                        } else {
                            SGM_draw();
                            SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, mFile.name);
                        }                        
finish_join:
                        // free joined file
                        if(mFile.size > 0)
                            free(mFile.data);
                    }
                    break;
                    
                case MENU_FORMAT:
                    SGM_format();
                    break;
                    
                case MENU_DECOMPRESS_TYPE:
                    // toggle small & slow and big & fast decompression
                    if(small == 0)
                        small = 1;
                    else small = 0;
                    break;
                    
                case MENU_COMPRESS_LEVEL:
                    if((push & PER_DGT_TA) == 0) {
                        // decrease compression quality
                        if(blockSize100k > 1)
                            blockSize100k--;
                    }
                    if((push & PER_DGT_TC) == 0) {
                        // limit compression quality increase
                        // by available cart RAM
                        if(((CartID == CARTRAM_ID_8M) && (blockSize100k < 2)) || ((CartID == CARTRAM_ID_32M) && (blockSize100k < 4)))
                            blockSize100k++;
                    }    
                    break;
                    
                case MENU_SET_START:
                    {
                        Uint8 *addr = (Uint8 *)startAddr;
                        SGM_MemoryViewer(&addr, 0x20000000, 0x26100000-1);
                        startAddr = (Uint32)addr;
                    }
                    break;
                    
                case MENU_SET_END:
                    {
                        Uint8 *addr = (Uint8 *)endAddr;
                        SGM_MemoryViewer(&addr, 0x20000000, 0x26100000-1);
                        endAddr = (Uint32)addr;
                    }
                    break;
                    
                case MENU_DUMP:
                    if(startAddr <= endAddr) {
                        MemoryFile mFile;
                        // set up file
                        mFile.data = (void *)startAddr;
                        mFile.size = endAddr - startAddr + 1;
                            // write file attributes
                        set_date(&mFile);
                        char comment[] = "My_Comment";
                        memcpy(mFile.comment, comment, 11);
                        char name[] = "My_File____";
                        memcpy(mFile.name, name, 12);
                        SGM_string("Specify file name:", 11, mFile.name);
                        SGM_string("Specify file comment:", 10, mFile.comment);
                        // create a new empty virtual drive
                        if(appendDevice(DEVICE_VIRTUAL) == 0) {
                            // show new drive in unselected slot
                            activeDevices[inactiveSlot] = nDevices - 1;
                            if(iDevice->saveFile(iDevice, &mFile) == 0) {            
                                SGM_draw();
                                SGM_confirm(0xFFFF, CONFIRM_SAVE_SUCCESS, mFile.name);
                            } else {
                                // display dir changes
                                SGM_draw();
                                SGM_confirm(0xFFFF, CONFIRM_SAVE_ERROR, mFile.name);
                            }
                        } else SGM_confirm(0xFFFF, CONFIRM_ERROR, "appending Device");
                        while((Smpc_Peripheral[0].data & PER_DGT_ST) == 0)
                            slSynch();
//                        were_here("dump addr: %x file data: %x", startAddr, mFile.data);
                    }    
                    break;
                    
                case MENU_CD_STOP:
                    {
                        CdcPos poswk;
                        // seek home position
                        CDC_POS_PTYPE(&poswk) = CDC_PTYPE_DFL;
                        CDC_CdSeek(&poswk);
                    }    
                    break;

                case MENU_CD_RESCAN:
                    updateDir_CD(device + DEVICE_CD_DRIVE);
                    break;
                    
            }
        }
        // redraw?
        if(redraw)
            SGM_menu_draw();
        
        slSynch();
    }
}
