//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#include <SGM_popup.h>

/****************************************************************************************************/
/* message pop-up system ****************************************************************************/
/****************************************************************************************************/

char *CONFIRM_ERROR[] = {
    "|----------------------------|",
    "| An ERROR occured, message: |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_WRITE_PROTECTED[] = {
    "|----------------------------|",
    "|         Device is          |",
    "|      write protected!      |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_LOAD_ERROR[] = {
    "|----------------------------|",
    "|     ERROR loading file     |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_SAVE[] = {
    "|----------------------------|",
    "|     Saving that file?      |",
    "|                            |",
    "|>>>>> Confirm with A/C <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_SAVE_ERROR[] = {
    "|----------------------------|",
    "|     ERROR saving file      |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_SAVE_SUCCESS[] = {
    "|----------------------------|",
    "|  Successfully saved file   |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_COPY[] = {
    "|----------------------------|",
    "|      Copy that file?       |",
    "|                            |",
    "|>>>>>  Confirm with A  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_COPY_SUCCESS[] = {
    "|----------------------------|",
    "|  Successfully copied file  |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DELETE[] = {
    "|----------------------------|",
    "|     Delete that file?      |",
    "|                            |",
    "|>>>>>  Confirm with B  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DELETE_SUCCESS[] = {
    "|----------------------------|",
    "|  Successfully deleted file |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DELETE_ERROR[] = {
    "|----------------------------|",
    "|     ERROR deleting file    |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_FORMAT[] = {
    "|----------------------------|",
    "|     Format this device?    |",
    "|                            |",
    "|>>>>>  Confirm with C  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_FORMAT_SUCCESS[] = {
    "|----------------------------|",
    "|Successfully formated device|",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_FORMAT_ERROR[] = {
    "|----------------------------|",
    "|   ERROR formating device   |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_COMPRESS[] = {
    "|----------------------------|",
    "|   Compress this device?    |",
    "|                            |",
    "|>>>>>  Confirm with Z  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_COMPRESS_SUCCESS[] = {
    "|----------------------------|",
    "|  Device compressed as file |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_COMPRESS_ERROR[] = {
    "|----------------------------|",
    "|  ERROR compressing device  |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DECOMPRESS[] = {
    "|----------------------------|",
    "|   Decompress this file?    |",
    "|                            |",
    "|>>>>>  Confirm with Y  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DECOMPRESS_SUCCESS[] = {
    "|----------------------------|",
    "|  Device decompressed from  |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DECOMPRESS_ERROR[] = {
    "|----------------------------|",
    "|  ERROR decompressing file  |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};

//char *CONFIRM_FLASH_DATEL[] = {
//    "|----------------------------|",
//    "|  Exit SGM and flash cart   |",
//    "|                            |",
//    "|>>>>>  Confirm with X  <<<<<|",
//    "|----------------------------|",
//};
//
//char *CONFIRM_FLASH_AR4MP[] = {
//    "|----------------------------|",
//    "|  Exit SGM and flash cart   |",
//    "|                            |",
//    "|>>>>>  Confirm with Y  <<<<<|",
//    "|----------------------------|",
//};
//
//char *CONFIRM_FLASH_ARP[] = {
//    "|----------------------------|",
//    "|  Exit SGM and flash cart   |",
//    "|                            |",
//    "|>>>>>  Confirm with Z  <<<<<|",
//    "|----------------------------|",
//};
char *CONFIRM_FLASH[] = {
    "|----------------------------|",
    "|  Exit SGM and flash cart   |",
    "|                            |",
    "|>>>>> Confirm with A/C <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DIRCHANGE_SUCCESS[] = {
    "|----------------------------|",
    "|     Directory changed      |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_DIRCHANGE_ERROR[] = {
    "|----------------------------|",
    "|  ERROR changing directory  |",
    "|                            |",
    "|>>>>> Press any button <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_OVERWRITE_A[] = {
    "|----------------------------|",
    "|      Overwrite file?       |",
    "|                            |",
    "|>>>>>  Confirm with A  <<<<<|",
    "|----------------------------|",
};
char *CONFIRM_OVERWRITE_Z[] = {
    "|----------------------------|",
    "|      Overwrite file?       |",
    "|                            |",
    "|>>>>>  Confirm with Z  <<<<<|",
    "|----------------------------|",
};

void SGM_drawConfirm(char **message, char *filename)
{
    int i;
    for(i = 0; i < 5; i++)
        slPrint(*(message + i), slLocate(7, 12 + i));
        
    slPrint(filename, slLocate(7 + 9, 12 + 2));    
}

int SGM_confirm(Uint16 button, char **message, char *filename)
{
    Uint16 push, b2 = (~button) & 0xFFF8; //^ (PER_KBD_CL | PER_KBD_NL | PER_KBD_SL | PER_KBD_MK | PER_KBD_BR);
    int i;
    
    SGM_drawConfirm(message, filename);
    
    waitRelease(0xFFFF);
    
    // for a period of time,
    // check if confirmed or denied
    for(i = 0; i < 200; i++) {
        getfirstPadInput(NULL, &push, NULL);
        if((push & button) != button)
            // pressed a confirm button
            return 1;
        else {
        if((push & b2) != b2)
            // pressed deny button
            return 0;
        }
        slSynch();
    }
    // time elapsed,
    // deny per default
    return 0;
}

